;------------------------------------------------
;
;                  TUTO  -  ASM
;
;------------------------------------------------
;    Essai de programmation d'un jeu en ASM
;------------------------------------------------
;				  MSXosaure 2014...
;------------------------------------------------
;
;------------------------------------------------
;                 Initialisation
;------------------------------------------------
       .bios
       .page   2
       .rom
       .start  DEBUT
;
;------------------------------------------------
; 			Constantes VRAM
;------------------------------------------------
       CHRTBL  equ     0000h
       NAMTBL  equ     1800h
       CLRTBL  equ     2000h
       SPRTBL  equ     3800h
       SPRATR  equ     1b00h
;------------------------------------------------
DEBUT:
; slection screen
       call    DISSCR
; rglage COLOR 11,1,1
        ld      hl,0f3e9h
        ld      [hl],15
        inc     hl
        ld      [hl],12
        inc     hl
        ld      [hl],1
; SCREEN 2
        call    INIGRP
; SCREEN ,2
        ld      bc,06201h
        call    WRTVDP
; Definition des formes sprites
        ld      hl,SPR_PATRON
        ld      de,SPRTBL; + 32
        ld      bc,20*32
        call    LDIRVM	
; initialisation des attributs sprites
        ld      hl,ATT_SPRITES	; on prend les paramtres initiaux
        ld      de,SPRATR		;  envoyer vers la table des attributs des sprites en VRAM
        ld      bc,2*4			; nombre de sprites * nb d'attributs (a va voluer)
        call    LDIRVM			; la routine de copie en VRAM
        ld      hl,SPRATR		; on prend les paramtres de la VRAM
        ld      de,VAR_SPRITES	;  envoyer vers les variables des sprites
        ld      bc,2*4			; nombre de sprites * nb d'attributs (a va voluer)
        call    LDIRMV			; la routine de copie de VRAM en RAM
; Installation de la routine d'interruption
        ld      hl,$fd9f		; on met le crochet "d'interruption"(H.TIMI) dans hl
        ld      bc,INTERRUPTION	; On met l'adresse de notreinterruption dans bc
        ld      [hl],$c3		; on remplace la premire instruction par jump
        inc     hl				;puis ensuite
        ld      [hl],c			;l'adresse 
        inc     hl				;de notre 
        ld      [hl],b  		;interruption.
		xor		a				;mise  0
		ld		[VAR_TEMPO],a	; de la variable de la tempo		
;
;-----------------------------------------------!
;												!
;												!
;												!
;			   BOUCLE PRINCIPALE				!
;												!
;												!
;												!
LOOP:
	call 	GST_DEP_Heros	
	call 	GST_SPRITES	
	call	GST_TEMPO		; Gestion timing 
jp		LOOP
;-----------------------------------------------!
;
;
;
;- - - SOUS PROGRAMME BOUCLE	- - -
;
;----------------------------------------------------------
GST_DEP_Heros:	;---- 	Gestion mouvement 	-----
;----------------------------------------------------------
;
    xor     a			; A=0 (test clavier) 
    call    GTSTCK		; A= direction flches clavier 
    cp      0			; Si A=0
    jr     	nz,@@GST_MOVE	; si non (a<>0) saut  la boucle  
    inc     a			; si oui A=A+1 (A=1)
    call    GTSTCK		; A= direction manette 1 
;  
;	Gestion mouvement
@@GST_MOVE:
    push  	af			; sauve A (valeur joystick)
; Dplacement horizontaux
    ld	hl,VAL_DEP_X	; HL = adr. dplacement X
	ld	b,0				; mise dans BC de A
	ld	c,a				; 	"
	add	hl,bc			; HL = On met HL  l'adresse correspondant  adresse de dplacement en X + position manette.
	ld	a,[hl]			; a = val. dplacement X
	ld	b,a				; B = val. dplacement X
	ld	a,[VAR_SPRITES+1] 	; a=X avant dplacement
	add	b				; a=a+val. dplacement X
	cp 	6				; si X=X mini -2 (<  X mini)
	jr 	nz,@@X_MAX		; si non saut  X_MAX
	ld	a,8			; si oui X=X mini
	jp	@@X_MAJ			; et saut  MAJ de X
@@X_MAX:
	cp 	234				; si X=X maxi +2 (>  X maxi)
	jr 	nz,@@X_MAJ		; si non saut  MAJ de X
	ld	a,232			; si oui X=X maxi
@@X_MAJ:
	ld 	[VAR_SPRITES+(0*4)+1],a	; X 1er sprite heros (plan0)
	ld 	[VAR_SPRITES+(1*4)+1],a  	; X 2nd sprite heros(plan1)
; Dplacement verticaux
	pop af			; recup de A (valeur joystick)	
    ld	hl,VAL_DEP_Y	; HL = adr. dplacement Y
	ld	b,0				; mise dans BC de A
	ld	c,a				; 	"
	add	hl,bc			; HL = On met HL  l'adresse correspondant  adresse de dplacement en Y + position manette.
	ld	a,[hl]		; A = val. dplacement Y
	ld	b,a			; B = val. dplacement Y
	ld 	a,[VAR_SPRITES]	; A=Y avant dplacement
	add	b			; A=a+val. dplacement Y
	cp 	6			; si Y=Y mini -2 (<  Y mini)
	jr 	nz,@@Y_MAX	; si non saut  Y_MAX
	ld	a,8			; si oui Y=Y mini
	jp	@@Y_MAJ		; et saut  MAJ de Y
@@Y_MAX:
	cp 	172			; si Y=Y maxi +2 (>  Y maxi)
	jr 	nz,@@Y_MAJ	; si non saut  MAJ de Y
	ld	a,170		; si oui Y=Y maxi
@@Y_MAJ:
	ld 	[VAR_SPRITES+(0*4)],a	; Y 1er sprite heros (plan0)
	ld 	[VAR_SPRITES+(1*4)],a  	; Y 2nd sprite heros(plan1)
ret	; Retour  la boucle principale
;
;----------------------------------------------------------
GST_TEMPO:
;----------------------------------------------------------
;
		ld	a,[VAR_TEMPO]	;
		ld	b,a				;
		ld	a,50			;
		sub	b				;
		ld	b,a				;
		xor	a				;
		ld	[VAR_TEMPO],a	;	
@@time:				;		
	push	bc		;
	ld	b,30		;
@@time2:			;
nop					;
djnz	@@time2		;
	pop	bc			;
	djnz	@@time	;
		ret			;
;------------------------------------------------------
;
;- - - 		SOUS PROGRAMME		- - -
;
;------------------------------------------------------
;
;------------------------------------------------------
GST_SPRITES:	;- envoi variables vers sprites 
;------------------------------------------------------
;
        ld      hl,VAR_SPRITES	; on prend les variables des sprites
        ld      de,SPRATR		;  envoyer vers les attributs de sprites en VRAM
        ld      bc,2*4			; nombre de sprites * nb d'attributs (a va voluer)
        call    LDIRVM			; c'est parti!
ret	
;
;----------------------------------------------------------
INTERRUPTION:	;- on incrmente automatiquement et rgulirement
;----------------------------------------------------------
;
        push    af				;on
        push    bc				;	sauve
        push    de				;		tout
        push    hl				;			!
        ld		hl,VAR_TEMPO	; la variable de tempo
		inc		[hl]			; est incrmente
        pop     hl				;on
        pop     de				;	rcupre
        pop     bc				;		tout
        pop     af				;			!
        ret
;
;----------------------------------------------------------
; 						Donnes
;----------------------------------------------------------
;		
; Patron des sprites
SPR_PATRON:
.INCLUDE"data_sprites.asm"	
;
; Attribut sprites 
;
; X, Y, N, Couleur
ATT_SPRITES:
	db	80,80,16,1	
	db	80,80,20,11	
; Test dplacement
VAL_DEP_X:
;------ 0,1,2,3,4,5,6, 7,8
	db  0,0,0,2,0,0,0,-2,0
VAL_DEP_Y:
;------ 0, 1,2,3,4,5,6, 7,8
	db  0,-2,0,0,0,2,0,0,0
;
;----------------------------------------------------------
; VARIABLES
;----------------------------------------------------------
        .page   3
;
; variables sprites
VAR_SPRITES:
    ds  2*4
; variable pour la tempo
VAR_TEMPO:	
	ds	1